Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -4854,67 +4917,113 @@
        CASE(1)
 
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
           CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit,  zksa, zkocnv )
 !
-!--    Activation type nucleation
+!--    Activation type nucleation (See Riipinen et al. (2007), Atmos. Chem. Phys., 7(8), 1899-1914)
        CASE(2)
-
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa,  znoc, zdcrit, zksa, zkocnv )
-          CALL actnucl( pc_sa, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv, act_coeff )
+!
+!--       Nucleation rate (#/(m3 s))
+          zc_h2so4  = MAX( zc_h2so4, 1.0E4_wp  )
+          zc_h2so4  = MIN( zc_h2so4, 1.0E11_wp )
+          zjnuc = act_coeff * pc_sa  ! (#/(m3 s))
+!
+!--       Organic compounds not involved when kinetic nucleation is assumed.
+          zdcrit  = 7.9375E-10_wp   ! (m)
+          zkocnv  = 0.0_wp
+          zksa    = 1.0_wp
+          znoc    = 0.0_wp
+          znsa    = 2.0_wp
 !
 !--    Kinetically limited nucleation of (NH4)HSO4 clusters
+!--    (See Sihto et al. (2006), Atmos. Chem. Phys., 6(12), 4079-4091.)
        CASE(3)
-
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL kinnucl( zc_h2so4, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--       Nucleation rate = coagcoeff*zpcsa**2 (#/(m3 s))
+          zc_h2so4  = MAX( zc_h2so4, 1.0E4_wp  )
+          zc_h2so4  = MIN( zc_h2so4, 1.0E11_wp )
+          zjnuc = 5.0E-13_wp * zc_h2so4**2.0_wp * 1.0E+6_wp
+!
+!--       Organic compounds not involved when kinetic nucleation is assumed.
+          zdcrit  = 7.9375E-10_wp   ! (m)
+          zkocnv  = 0.0_wp
+          zksa    = 1.0_wp
+          znoc    = 0.0_wp
+          znsa    = 2.0_wp
 !
 !--    Ternary H2SO4-H2O-NH3 nucleation
        CASE(4)
 
-          zmixnh3 = pc_nh3 * ptemp * argas / ( ppres * avo )
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
           CALL ternucl( zc_h2so4, zmixnh3, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
 !
 !--    Organic nucleation, J~[ORG] or J~[ORG]**2
+!--    (See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.)
        CASE(5)
-
-          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL orgnucl( pc_ocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--       Homomolecular nuleation rate
+          zjnuc = 1.3E-7_wp * pc_ocnv   ! (1/s) (Paasonen et al. Table 4: median a_org)
+!
+!--       H2SO4 not involved when pure organic nucleation is assumed.
+          zdcrit  = 1.5E-9  ! (m)
+          zkocnv  = 1.0_wp
+          zksa    = 0.0_wp
+          znoc    = 1.0_wp
+          znsa    = 0.0_wp
 !
 !--    Sum of H2SO4 and organic activation type nucleation, J~[H2SO4]+[ORG]
+!--    (See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242)
        CASE(6)
-
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL sumnucl( pc_sa, pc_ocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-!
-!--    Heteromolecular nucleation, J~[H2SO4]*[ORG]
+!
+!--       Nucleation rate  (#/m3/s)
+          zjnuc = 6.1E-7_wp * pc_sa + 0.39E-7_wp * pc_ocnv   ! (Paasonen et al. Table 3.)
+!
+!--       Both organic compounds and H2SO4 are involved when sumnucleation is assumed.
+          zdcrit  = 1.5E-9_wp   ! (m)
+          zkocnv  = 1.0_wp
+          zksa    = 1.0_wp
+          znoc    = 1.0_wp
+          znsa    = 1.0_wp
+!
+!--    Heteromolecular nucleation, J~[H2SO4]*[ORG] 
+!--    (See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.)
        CASE(7)
-
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL hetnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--       Nucleation rate (#/m3/s)
+          zjnuc = 4.1E-14_wp * pc_sa * pc_ocnv * 1.0E6_wp   ! (Paasonen et al. Table 4: median)
+!
+!--       Both organic compounds and H2SO4 are involved when heteromolecular nucleation is assumed
+          zdcrit  = 1.5E-9_wp   ! (m)
+          zkocnv  = 1.0_wp
+          zksa    = 1.0_wp
+          znoc    = 1.0_wp
+          znsa    = 1.0_wp
 !
 !--    Homomolecular nucleation of H2SO4 and heteromolecular nucleation of H2SO4 and organic vapour,
 !--    J~[H2SO4]**2 + [H2SO4]*[ORG] (EUCAARI project)
+!--    (See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242)
        CASE(8)
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL SAnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--       Nucleation rate (#/m3/s)
+          zjnuc = ( 1.1E-14_wp * zc_h2so4**2 + 3.2E-14_wp * zc_h2so4 * zc_org ) * 1.0E+6_wp
+!
+!--       Both organic compounds and H2SO4 are involved when SAnucleation is assumed
+          zdcrit  = 1.5E-9_wp   ! (m)
+          zkocnv  = 1.0_wp
+          zksa    = 1.0_wp
+          znoc    = 1.0_wp
+          znsa    = 3.0_wp
 !
 !--    Homomolecular nucleation of H2SO4 and organic vapour and heteromolecular nucleation of H2SO4
 !--    and organic vapour, J~[H2SO4]**2 + [H2SO4]*[ORG]+[ORG]**2 (EUCAARI project)
        CASE(9)
-
-          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
-          CALL SAORGnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--       Nucleation rate (#/m3/s)
+          zjnuc = ( 1.4E-14_wp * zc_h2so4**2 + 2.6E-14_wp * zc_h2so4 * zc_org + 0.037E-14_wp *     &
+                    zc_org**2 ) * 1.0E+6_wp
+!
+!--       Both organic compounds and H2SO4 are involved when SAORGnucleation is assumed
+          zdcrit  = 1.5E-9_wp   ! (m)
+          zkocnv  = 1.0_wp
+          zksa    = 1.0_wp
+          znoc    = 3.0_wp
+          znsa    = 3.0_wp
 
     END SELECT
@@ -5010,9 +5119,9 @@
 !
 !--    Defining the parameter m (zm_para) for calculating the coagulation sink onto background
-!--    particles (Eq. 5&6 in Lehtinen et al. 2007). The growth is investigated between 
+!--    particles (Eq. 5&6 in Lehtinen et al. 2007). The growth is investigated between
 !--    [d1,reglim(1)] = [zdcrit,3nm] and m = LOG( CoagS_dx / CoagX_zdcrit ) / LOG( reglim / zdcrit )
 !--    (Lehtinen et al. 2007, Eq. 6).
-!--    The steps for the coagulation sink for reglim = 3nm and zdcrit ~= 1nm are explained in 
-!--    Kulmala et al. (2001). The particles of diameter zdcrit ~1.14 nm  and reglim = 3nm are both 
+!--    The steps for the coagulation sink for reglim = 3nm and zdcrit ~= 1nm are explained in
+!--    Kulmala et al. (2001). The particles of diameter zdcrit ~1.14 nm  and reglim = 3nm are both
 !--    in turn the "number 1" variables (Kulmala et al. 2001).
 !--    c = critical (1nm), x = 3nm, 2 = wet or mean droplet
@@ -5129,5 +5238,5 @@
              z_gr_tot = z_gr_clust * 2.77777777E-7_wp +  1.5708E-6_wp * zlambda * zdcrit**3 *      &
                       ( z_n_nuc * 1.0E-6_wp ) * zcv_c * avo * 2.77777777E-7_wp ! (Eq. 3)
-             zeta = - zcoagstot / ( ( zm_para + 1.0_wp ) * z_gr_tot * ( zdcrit**zm_para ) ) ! (Eq. 7b)
+             zeta = - zcoagstot / ( ( zm_para + 1.0_wp ) * z_gr_tot * ( zdcrit**zm_para ) ) ! (Eq.7b)
 !
 !--          Calculate Eq. 7a (Taylor series for the number of particles between [d1,dx])
@@ -5139,5 +5248,5 @@
           z_gr_tot = z_gr_clust * 1.0E-9_wp / 3600.0_wp + 1.5708E-6_wp *  zlambda * zdcrit**3 *    &
                    ( z_n_nuc * 1.0E-6_wp ) * zcv_c * avo * 1.0E-9_wp / 3600.0_wp !< (m/s)
-          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zcoagstot / z_gr_tot ) ) ! (#/m3s, Eq. 5a)
+          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zcoagstot / z_gr_tot ) ) ! (#/m3s, Eq.5a)
 
        ENDIF
@@ -5145,6 +5254,6 @@
 !
 !-- If J3 very small (< 1 #/cm3), neglect particle formation. In real atmosphere this would mean
-!-- that clusters form but coagulate to pre-existing particles who gain sulphate. Since 
-!-- CoagS ~ CS (4piD*CS'), we do *not* update H2SO4 concentration here but let condensation take 
+!-- that clusters form but coagulate to pre-existing particles who gain sulphate. Since
+!-- CoagS ~ CS (4piD*CS'), we do *not* update H2SO4 concentration here but let condensation take
 !-- care of it. Formation mass rate of molecules (molec/m3s) for 1: H2SO4 and 2: organic vapour
     pj3n3(1) = zj3 * n3 * pxsa
@@ -5156,8 +5265,8 @@
 ! Description:
 ! ------------
-!> Calculate the nucleation rate and the size of critical clusters assuming 
+!> Calculate the nucleation rate and the size of critical clusters assuming
 !> binary nucleation.
-!> Parametrisation according to Vehkamaki et al. (2002), J. Geophys. Res., 
-!> 107(D22), 4622. Called from subroutine nucleation. 
+!> Parametrisation according to Vehkamaki et al. (2002), J. Geophys. Res.,
+!> 107(D22), 4622. Called from subroutine nucleation.
 !------------------------------------------------------------------------------!
  SUBROUTINE binnucl( pc_sa, ptemp, prh, pnuc_rate, pn_crit_sa, pn_crit_ocnv, pd_crit, pk_sa,       &
@@ -5519,257 +5628,4 @@
 
  END SUBROUTINE ternucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Calculate the nucleation rate and the size of critical clusters assuming
-!> kinetic nucleation. Each sulphuric acid molecule forms an (NH4)HSO4 molecule
-!> in the atmosphere and two colliding (NH4)HSO4 molecules form a stable
-!> cluster. See Sihto et al. (2006), Atmos. Chem. Phys., 6(12), 4079-4091.
-!>
-!> Below the following assumption have been made:
-!>  nucrate = coagcoeff*zpcsa**2
-!>  coagcoeff = 8*sqrt(3*boltz*ptemp*r_abs/dens_abs)
-!>  r_abs = 0.315d-9 radius of bisulphate molecule [m]
-!>  dens_abs = 1465  density of - " - [kg/m3]
-!------------------------------------------------------------------------------!
- SUBROUTINE kinnucl( pc_sa, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp), INTENT(in) ::  pc_sa  !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 is participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Nucleation rate (#/(m3 s))
-    pnuc_rate = 5.0E-13_wp * pc_sa**2.0_wp * 1.0E+6_wp
-!
-!-- Organic compounds not involved when kinetic nucleation is assumed.
-    pn_crit_sa   = 2.0_wp
-    pn_crit_ocnv = 0.0_wp
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 0.0_wp
-    pd_crit      = 7.9375E-10_wp   ! (m)
-
- END SUBROUTINE kinnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Calculate the nucleation rate and the size of critical clusters assuming 
-!> activation type nucleation.
-!> See Riipinen et al. (2007), Atmos. Chem. Phys., 7(8), 1899-1914.
-!------------------------------------------------------------------------------!
- SUBROUTINE actnucl( psa_conc, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv, activ )
-
-    IMPLICIT NONE
-
-    REAL(wp), INTENT(in) ::  activ     !< activation coefficient (1e-7 by default)
-    REAL(wp), INTENT(in) ::  psa_conc  !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Nucleation rate (#/(m3 s))
-    pnuc_rate = activ * psa_conc   ! (#/(m3 s))
-!
-!-- Organic compounds not involved when kinetic nucleation is assumed.
-    pn_crit_sa   = 2.0_wp
-    pn_crit_ocnv = 0.0_wp
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 0.0_wp
-    pd_crit      = 7.9375E-10_wp   ! (m)
-
- END SUBROUTINE actnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Conciders only the organic matter in nucleation. Paasonen et al. (2010) 
-!> determined particle formation rates for 2 nm particles, J2, from different
-!> kind of combinations of sulphuric acid and organic matter concentration.
-!> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
-!------------------------------------------------------------------------------!
- SUBROUTINE orgnucl( pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv,     &
-                     pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp) ::  a_org = 1.3E-7_wp  !< (1/s) (Paasonen et al. Table 4: median)
-
-    REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Homomolecular nuleation rate
-    pnuc_rate = a_org * pc_org
-!
-!-- H2SO4 not involved when pure organic nucleation is assumed.
-    pn_crit_sa   = 0.0_wp
-    pn_crit_ocnv = 1.0_wp
-    pk_sa        = 0.0_wp
-    pk_ocnv      = 1.0_wp
-    pd_crit      = 1.5E-9_wp   ! (m)
-
- END SUBROUTINE orgnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Conciders both the organic vapor and H2SO4 in nucleation - activation type 
-!> of nucleation. 
-!> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
-!------------------------------------------------------------------------------!
- SUBROUTINE sumnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp) ::  a_s1 = 6.1E-7_wp   !< (1/s)
-    REAL(wp) ::  a_s2 = 0.39E-7_wp  !< (1/s) (Paasonen et al. Table 3.)
-
-    REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-    REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Nucleation rate  (#/m3/s)
-    pnuc_rate = a_s1 * pc_sa + a_s2 * pc_org
-!
-!-- Both organic compounds and H2SO4 are involved when sumnucleation is assumed.
-    pn_crit_sa   = 1.0_wp
-    pn_crit_ocnv = 1.0_wp
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp
-    pd_crit      = 1.5E-9_wp   ! (m)
-
- END SUBROUTINE sumnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Conciders both the organic vapor and H2SO4 in nucleation - heteromolecular 
-!> nucleation. 
-!> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
-!------------------------------------------------------------------------------!
- SUBROUTINE hetnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp) ::  z_k_het = 4.1E-14_wp  !< (cm3/s) (Paasonen et al. Table 4: median)
-
-    REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-    REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Nucleation rate (#/m3/s)
-    pnuc_rate = z_k_het * pc_sa * pc_org * 1.0E6_wp
-!
-!-- Both organic compounds and H2SO4 are involved when heteromolecular
-!-- nucleation is assumed.
-    pn_crit_sa   = 1.0_wp
-    pn_crit_ocnv = 1.0_wp
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp
-    pd_crit      = 1.5E-9_wp   ! (m)
-
- END SUBROUTINE hetnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Takes into account the homomolecular nucleation of sulphuric acid H2SO4 with
-!> both of the available vapours.
-!> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
-!------------------------------------------------------------------------------!
- SUBROUTINE SAnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp) ::  z_k_sa1 = 1.1E-14_wp  !< (cm3/s)
-    REAL(wp) ::  z_k_sa2 = 3.2E-14_wp  !< (cm3/s) (Paasonen et al. Table 3.)
-
-    REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-    REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucleation rate (#/(m3 s))
-!
-!-- Nucleation rate (#/m3/s)
-    pnuc_rate = ( z_k_sa1 * pc_sa**2 + z_k_sa2 * pc_sa * pc_org ) * 1.0E+6_wp
-!
-!-- Both organic compounds and H2SO4 are involved when SAnucleation is assumed.
-    pn_crit_sa   = 3.0_wp
-    pn_crit_ocnv = 1.0_wp 
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp
-    pd_crit      = 1.5E-9_wp   ! (m)
-
- END SUBROUTINE SAnucl
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Takes into account the homomolecular nucleation of both sulphuric acid and 
-!> Lorganic with heteromolecular nucleation.
-!> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
-!------------------------------------------------------------------------------!
- SUBROUTINE SAORGnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
-
-    IMPLICIT NONE
-
-    REAL(wp) ::  z_k_s1 = 1.4E-14_wp    !< (cm3/s])
-    REAL(wp) ::  z_k_s2 = 2.6E-14_wp    !< (cm3/s])
-    REAL(wp) ::  z_k_s3 = 0.037E-14_wp  !< (cm3/s]) (Paasonen et al. Table 3.)
-
-    REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-    REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-
-    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
-!
-!-- Nucleation rate (#/m3/s)
-    pnuc_rate = ( z_k_s1 * pc_sa**2 + z_k_s2 * pc_sa * pc_org + z_k_s3 * pc_org**2 ) * 1.0E+6_wp
-!
-!-- Organic compounds not involved when kinetic nucleation is assumed.
-    pn_crit_sa   = 3.0_wp
-    pn_crit_ocnv = 3.0_wp
-    pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp
-    pd_crit      = 1.5E-9_wp   ! (m)
-
- END SUBROUTINE SAORGnucl
 
 !------------------------------------------------------------------------------!
@@ -8237,9 +8093,9 @@
 
           DO  ib = 1, nbins_aerosol
-             aerosol_number(ib)%conc_p(nzt+1,:,:) = aerosol_number(ib)%conc_p(nzt,:,:) +              &
+             aerosol_number(ib)%conc_p(nzt+1,:,:) = aerosol_number(ib)%conc_p(nzt,:,:) +           &
                                                     bc_an_t_val(ib) * dzu(nzt+1)
              DO  ic = 1, ncomponents_mass
                 icc = ( ic - 1 ) * nbins_aerosol + ib
-                aerosol_mass(icc)%conc_p(nzt+1,:,:) = aerosol_mass(icc)%conc_p(nzt,:,:) +             &
+                aerosol_mass(icc)%conc_p(nzt+1,:,:) = aerosol_mass(icc)%conc_p(nzt,:,:) +          &
                                                       bc_am_t_val(icc) * dzu(nzt+1)
              ENDDO
@@ -8247,5 +8103,5 @@
           IF ( .NOT. salsa_gases_from_chem )  THEN
              DO  ig = 1, ngases_salsa
-                salsa_gas(ig)%conc_p(nzt+1,:,:) = salsa_gas(ig)%conc_p(nzt,:,:) +                     &
+                salsa_gas(ig)%conc_p(nzt+1,:,:) = salsa_gas(ig)%conc_p(nzt,:,:) +                  &
                                                   bc_gt_t_val(ig) * dzu(nzt+1)
              ENDDO
@@ -8550,5 +8406,5 @@
         ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
                inquire_num_variables, inquire_variable_names,                                      &
-               netcdf_data_input_get_dimension_length, open_read_file
+               netcdf_data_input_get_dimension_length, open_read_file, street_type_f
 
     USE surface_mod,                                                                               &
@@ -8561,4 +8417,5 @@
     CHARACTER(LEN=25) ::  mod_name             !< name in the input file
 
+    INTEGER(iwp) ::  i         !< loop index
     INTEGER(iwp) ::  ib        !< loop index: aerosol number bins
     INTEGER(iwp) ::  ic        !< loop index: aerosol chemical components
@@ -8566,4 +8423,5 @@
     INTEGER(iwp) ::  in        !< loop index: emission category
     INTEGER(iwp) ::  inn       !< loop index
+    INTEGER(iwp) ::  j         !< loop index
     INTEGER(iwp) ::  ss        !< loop index
 
@@ -8579,19 +8437,8 @@
 
 !
-!-- Set source arrays to zero:
-    DO  ib = 1, nbins_aerosol
-       aerosol_number(ib)%source = 0.0_wp
-    ENDDO
-
-    DO  ic = 1, ncomponents_mass * nbins_aerosol
-       aerosol_mass(ic)%source = 0.0_wp
-    ENDDO
-
-!
 !-- Define emissions:
-
     SELECT CASE ( salsa_emission_mode )
 
-       CASE ( 'uniform' )
+       CASE ( 'uniform', 'parameterized' )
 
           IF ( init )  THEN  ! Do only once
@@ -8605,7 +8452,27 @@
              CALL size_distribution( surface_aerosol_flux, aerosol_flux_dpg, aerosol_flux_sigmag,  &
                                      nsect_emission )
-             DO  ib = 1, nbins_aerosol
-                source_array(:,:,ib) = nsect_emission(ib)
-             ENDDO
+             IF ( salsa_emission_mode == 'uniform' )  THEN
+                DO  ib = 1, nbins_aerosol
+                   source_array(:,:,ib) = nsect_emission(ib)
+                ENDDO
+             ELSE
+                IF ( street_type_f%from_file )  THEN
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         IF ( street_type_f%var(j,i) >= main_street_id  .AND.                      &
+                              street_type_f%var(j,i) < max_street_id )  THEN
+                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_main
+                         ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND.                  &
+                                  street_type_f%var(j,i) < main_street_id )  THEN
+                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_side
+                         ENDIF
+                      ENDDO
+                   ENDDO
+                ELSE
+                   WRITE( message_string, * ) 'salsa_emission_mode = "parameterized" but the '//  &
+                                              'street_type data is missing.'
+                   CALL message( 'salsa_emission_setup', 'PA0661', 1, 2, 0, 6, 0 )
+                ENDIF
+             ENDIF
 !
 !--          Check which chemical components are used
@@ -8622,14 +8489,16 @@
              aerosol_flux_mass_fracs_a = aerosol_flux_mass_fracs_a /                               &
                                          SUM( aerosol_flux_mass_fracs_a(1:ncc ) )
-!
-!--          Set uniform fluxes of default horizontal surfaces
-             CALL set_flux( surf_def_h(0), cc_i2m, aerosol_flux_mass_fracs_a, source_array )
+             IF ( salsa_emission_mode ==  'uniform' )  THEN
+!
+!--             Set uniform fluxes of default horizontal surfaces
+                CALL set_flux( surf_def_h(0), cc_i2m, aerosol_flux_mass_fracs_a, source_array )
+             ELSE
+!
+!--             Set fluxes normalised based on the street type on land surfaces
+                CALL set_flux( surf_lsm_h, cc_i2m, aerosol_flux_mass_fracs_a, source_array )
+             ENDIF
 
              DEALLOCATE( nsect_emission, source_array )
           ENDIF
-
-       CASE ( 'parameterized' )
-!
-!--       TO DO
 
        CASE ( 'read_from_file' )
@@ -8643,4 +8512,14 @@
           surf_usm_h%amsws = 0.0_wp
 
+!
+!--       Reset source arrays:
+          DO  ib = 1, nbins_aerosol
+             aerosol_number(ib)%source = 0.0_wp
+          ENDDO
+
+          DO  ic = 1, ncomponents_mass * nbins_aerosol
+             aerosol_mass(ic)%source = 0.0_wp
+          ENDDO
+
 #if defined( __netcdf )
 !
@@ -8658,4 +8537,9 @@
           IF ( init )  THEN
 !
+!--          Variable names
+             CALL inquire_num_variables( id_salsa, aero_emission_att%num_vars )
+             ALLOCATE( aero_emission_att%var_names(1:aero_emission_att%num_vars) )
+             CALL inquire_variable_names( id_salsa, aero_emission_att%var_names )
+!
 !--          Read the index and name of chemical components
              CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%ncc,         &
@@ -8663,31 +8547,37 @@
              ALLOCATE( aero_emission_att%cc_index(1:aero_emission_att%ncc) )
              CALL get_variable( id_salsa, 'composition_index', aero_emission_att%cc_index )
-             CALL get_variable( id_salsa, 'composition_name', aero_emission_att%cc_name,           &
-                                aero_emission_att%ncc )
+
+             IF ( check_existence( aero_emission_att%var_names, 'composition_name' ) )  THEN
+                CALL get_variable( id_salsa, 'composition_name', aero_emission_att%cc_name,        &
+                                   aero_emission_att%ncc )
+             ELSE
+                message_string = 'Missing composition_name in ' // TRIM( input_file_salsa )
+                CALL message( 'salsa_emission_setup', 'PA0657', 1, 2, 0, 6, 0 )
+             ENDIF
 !
 !--          Find the corresponding chemical components in the model
-             aero_emission_att%cc_input_to_model = 0
+             aero_emission_att%cc_in2mod = 0
              DO  ic = 1, aero_emission_att%ncc
                 in_name = aero_emission_att%cc_name(ic)
                 SELECT CASE ( TRIM( in_name ) )
                    CASE ( 'H2SO4', 'h2so4', 'SO4', 'so4' )
-                      aero_emission_att%cc_input_to_model(1) = ic
+                      aero_emission_att%cc_in2mod(1) = ic
                    CASE ( 'OC', 'oc', 'organics' )
-                      aero_emission_att%cc_input_to_model(2) = ic
+                      aero_emission_att%cc_in2mod(2) = ic
                    CASE ( 'BC', 'bc' )
-                      aero_emission_att%cc_input_to_model(3) = ic
+                      aero_emission_att%cc_in2mod(3) = ic
                    CASE ( 'DU', 'du' )
-                      aero_emission_att%cc_input_to_model(4) = ic
+                      aero_emission_att%cc_in2mod(4) = ic
                    CASE ( 'SS', 'ss' )
-                      aero_emission_att%cc_input_to_model(5) = ic
+                      aero_emission_att%cc_in2mod(5) = ic
                    CASE ( 'HNO3', 'hno3', 'NO', 'no' )
-                      aero_emission_att%cc_input_to_model(6) = ic
+                      aero_emission_att%cc_in2mod(6) = ic
                    CASE ( 'NH3', 'nh3', 'NH', 'nh' )
-                      aero_emission_att%cc_input_to_model(7) = ic
+                      aero_emission_att%cc_in2mod(7) = ic
                 END SELECT
 
              ENDDO
 
-             IF ( SUM( aero_emission_att%cc_input_to_model ) == 0 )  THEN
+             IF ( SUM( aero_emission_att%cc_in2mod ) == 0 )  THEN
                 message_string = 'None of the aerosol chemical components in ' // TRIM(            &
                                  input_file_salsa ) // ' correspond to the ones applied in SALSA.'
@@ -8706,9 +8596,4 @@
              CALL get_attribute( id_salsa, 'lod', aero_emission_att%lod, .FALSE.,                  &
                                  'aerosol_emission_values' )
-!
-!--          Variable names
-             CALL inquire_num_variables( id_salsa, aero_emission_att%num_vars )
-             ALLOCATE( aero_emission_att%var_names(1:aero_emission_att%num_vars) )
-             CALL inquire_variable_names( id_salsa, aero_emission_att%var_names )
 
 !
@@ -8738,6 +8623,11 @@
 !
 !--             Get emission category names and indices
-                CALL get_variable( id_salsa, 'emission_category_name', aero_emission_att%cat_name, &
-                                   aero_emission_att%ncat)
+                IF ( check_existence( aero_emission_att%var_names, 'emission_category_name' ) )  THEN
+                   CALL get_variable( id_salsa, 'emission_category_name',                          &
+                                      aero_emission_att%cat_name,  aero_emission_att%ncat )
+                ELSE
+                   message_string = 'Missing emission_category_name in ' // TRIM( input_file_salsa )
+                   CALL message( 'salsa_emission_setup', 'PA0658', 1, 2, 0, 6, 0 )
+                ENDIF
                 CALL get_variable( id_salsa, 'emission_category_index', aero_emission_att%cat_index )
 !
